#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf replimenu-0.9.tar.gz
    cd replimenu-0.9
    ed -s configuration >/dev/null <<EOF
/^PREFIX=/d
i
PREFIX=/usr
.
/^CFLAGS = .* -O2/
s/-O2/$CFLAGS/
w
q
EOF
    make
    strip -R .note -R .comment src/replimenu
    mkdir -p ../replimenu/bin
    cp src/replimenu ../replimenu/bin/
    cd ..
    rm -rf replimenu-0.9
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
